<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>Crypto Driver Internal Functions</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<table width=100%>
<tr>
  <td bgcolor="black" width="1"><a href="http://www.ti.com"><img border=0 src="../../tilogo.gif"></a></td>
  <td bgcolor="red"><img src="../../titagline.gif"></td>
</tr>
</table>
<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#groups">Modules</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">Crypto Driver Internal Functions<div class="ingroups"><a class="el" href="group___c_r_y_p_t_o___d_r_i_v_e_r.html">Crypto Driver</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>The section has a list of all the internal functions used by the driver.  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="groups"></a>
Modules</h2></td></tr>
<tr class="memitem:group___c_r_y_p_t_o___a_e_s___r_l___f_u_n_c_t_i_o_n"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___a_e_s___r_l___f_u_n_c_t_i_o_n.html">Crypto Driver AES Register Level Functions</a></td></tr>
<tr class="memdesc:group___c_r_y_p_t_o___a_e_s___r_l___f_u_n_c_t_i_o_n"><td class="mdescLeft">&#160;</td><td class="mdescRight">The section has a list of all the AES functions used internally by the driver. <br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:group___c_r_y_p_t_o___h_m_a_c___r_l___f_u_n_c_t_i_o_n"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___h_m_a_c___r_l___f_u_n_c_t_i_o_n.html">Crypto Driver HMAC Register Level Functions</a></td></tr>
<tr class="memdesc:group___c_r_y_p_t_o___h_m_a_c___r_l___f_u_n_c_t_i_o_n"><td class="mdescLeft">&#160;</td><td class="mdescRight">The section has a list of all the HMAC functions used internally by the driver. <br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ga7c896e6400fbde163e1e0d696714f6eb"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___i_n_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga7c896e6400fbde163e1e0d696714f6eb">AES_processData</a> (<a class="el" href="reg__aes_8h.html#acee492b148e2b4b2c099c83bde564c4c">AESRegs</a> *baseAddress, const uint8_t *ptrInput, uint8_t *ptrOutput, uint32_t dataLen)</td></tr>
<tr class="separator:ga7c896e6400fbde163e1e0d696714f6eb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad876b8a533d8d57776a569a55ac2f4ca"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___i_n_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gad876b8a533d8d57776a569a55ac2f4ca">AES_generateDataMAC</a> (<a class="el" href="reg__aes_8h.html#acee492b148e2b4b2c099c83bde564c4c">AESRegs</a> *baseAddress, const uint8_t *ptrInput, uint8_t *ptrTag, uint32_t dataLen)</td></tr>
<tr class="separator:gad876b8a533d8d57776a569a55ac2f4ca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gae547b4689e702f0d5d16d89588529237"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___i_n_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gae547b4689e702f0d5d16d89588529237">AES_processDataAE</a> (<a class="el" href="reg__aes_8h.html#acee492b148e2b4b2c099c83bde564c4c">AESRegs</a> *baseAddress, const uint8_t *ptrInput, uint8_t *ptrOutput, uint32_t dataLen, const uint8_t *ptrAuthInput, uint8_t *ptrTag, uint32_t authDataLen)</td></tr>
<tr class="separator:gae547b4689e702f0d5d16d89588529237"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gae624ba361bba79c602be5a004428ab9d"><td class="memItemLeft" align="right" valign="top">static uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___i_n_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gae624ba361bba79c602be5a004428ab9d">Crypto_getAesConfig</a> (<a class="el" href="group___c_r_y_p_t_o___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga666a80fde1895d919c31bbd4923c6177">Crypto_AESMode</a> mode, <a class="el" href="group___c_r_y_p_t_o___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga72562d733e0bb69b07ac3f5f42afb10b">Crypto_EncryptParams</a> *ptrParams)</td></tr>
<tr class="separator:gae624ba361bba79c602be5a004428ab9d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gab68227c548eeab7a5853932ebc242cc1"><td class="memItemLeft" align="right" valign="top">static int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___i_n_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gab68227c548eeab7a5853932ebc242cc1">Crypto_aesProcess</a> (<a class="el" href="group___c_r_y_p_t_o___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gacd1d473b2a25119de6fa28a6b7bacfd1">Crypto_Config</a> *ptrCryptoConfig, <a class="el" href="group___c_r_y_p_t_o___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga666a80fde1895d919c31bbd4923c6177">Crypto_AESMode</a> mode, uint32_t cryptoDirection, uint8_t *ptrInput, uint32_t dataLength, uint8_t *ptrOutput, <a class="el" href="group___c_r_y_p_t_o___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga72562d733e0bb69b07ac3f5f42afb10b">Crypto_EncryptParams</a> *ptrParams)</td></tr>
<tr class="separator:gab68227c548eeab7a5853932ebc242cc1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga414429138668a818f1236737c5d8a945"><td class="memItemLeft" align="right" valign="top">static int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___i_n_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga414429138668a818f1236737c5d8a945">Crypto_hmacProcess</a> (<a class="el" href="group___c_r_y_p_t_o___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gacd1d473b2a25119de6fa28a6b7bacfd1">Crypto_Config</a> *ptrCryptoConfig, uint32_t cryptoConfig, uint8_t *ptrInput, uint32_t dataLength, uint8_t *ptrSignature, <a class="el" href="group___c_r_y_p_t_o___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga8df97ec732f045d62928e614531366b7">Crypto_HmacParams</a> *ptrParams)</td></tr>
<tr class="separator:ga414429138668a818f1236737c5d8a945"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga2dd3afef125ee439e8009fc4c486bcc0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___i_n_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga2dd3afef125ee439e8009fc4c486bcc0">HMAC_writeDataMultiple</a> (<a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *hmacBaseAddress, const uint8_t *ptrData, uint32_t dataLength)</td></tr>
<tr class="separator:ga2dd3afef125ee439e8009fc4c486bcc0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga2bb6398a1750093efe34b44b884a36d8"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___i_n_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga2bb6398a1750093efe34b44b884a36d8">HMAC_computeHash</a> (<a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *hmacBaseAddress, const uint8_t *ptrData, uint32_t dataLength, uint8_t *ptrHashResult)</td></tr>
<tr class="separator:ga2bb6398a1750093efe34b44b884a36d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gac9a79b134c8df9a39906ec7efc0a2f4f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___i_n_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gac9a79b134c8df9a39906ec7efc0a2f4f">HMAC_generateHMACPPKey</a> (<a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *hmacBaseAddress, const uint8_t *ptrKey, uint32_t keySize, uint8_t *ptrPPKey)</td></tr>
<tr class="separator:gac9a79b134c8df9a39906ec7efc0a2f4f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>The section has a list of all the internal functions used by the driver. </p>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="gad876b8a533d8d57776a569a55ac2f4ca"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void AES_generateDataMAC </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="reg__aes_8h.html#acee492b148e2b4b2c099c83bde564c4c">AESRegs</a> *&#160;</td>
          <td class="paramname"><em>baseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>ptrInput</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>ptrTag</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>dataLen</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 The function generates the MAC(message authentication code) using CBC-MAC and F9 mode. Note: The AES module must be configured for mode(CBC-MAC or F9), keys etc. before calling this function.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">baseAddress</td><td>Base address of AES module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ptrInput</td><td>Pointer to the input data buffer. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">ptrTag</td><td>Pointer to the 16 byte tag data buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dataLen</td><td>Data length of the input buffer in bytes.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Not</td><td>applicable </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga7c896e6400fbde163e1e0d696714f6eb"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void AES_processData </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="reg__aes_8h.html#acee492b148e2b4b2c099c83bde564c4c">AESRegs</a> *&#160;</td>
          <td class="paramname"><em>baseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>ptrInput</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>ptrOutput</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>dataLen</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 The function processes(encrypt or decrypt) a block of input data and stores the output data into a user specified output buffer. The function chunks the block of data into 16 byte chunks for processing. Note: The AES module must be configured for mode, keys etc. before calling this function.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">baseAddress</td><td>Base address of AES module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ptrInput</td><td>Pointer to the input data buffer. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">ptrOutput</td><td>Pointer to the output data buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dataLen</td><td>Data length in bytes. Valid values are 1 to less than 2^32.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Not</td><td>applicable </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="gae547b4689e702f0d5d16d89588529237"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void AES_processDataAE </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="reg__aes_8h.html#acee492b148e2b4b2c099c83bde564c4c">AESRegs</a> *&#160;</td>
          <td class="paramname"><em>baseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>ptrInput</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>ptrOutput</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>dataLen</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>ptrAuthInput</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>ptrTag</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>authDataLen</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 The function processes(encrypt or decrypt) and authenticates a block of input data and stores the output data into a user specified output buffer. It also generates the MAC(message authentication code). Note: The AES module MUST be configured for mode(Only CCM and GCM modes should be used), keys etc. before calling this function. Note: The input data, output data and authentication data MUST be padded to the 16-byte boundary.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">baseAddress</td><td>Base address of AES module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ptrInput</td><td>Pointer to the input data buffer. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">ptrOutput</td><td>Pointer to the output data buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dataLen</td><td>Data length of the input buffer in bytes. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ptrAuthInput</td><td>Pointer to the authentication input data buffer. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">ptrTag</td><td>Pointer to the 16 byte hash tag data buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">authDataLen</td><td>Data length of the authentication input data buffer in bytes.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Not</td><td>applicable </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="gab68227c548eeab7a5853932ebc242cc1"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int32_t Crypto_aesProcess </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group___c_r_y_p_t_o___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gacd1d473b2a25119de6fa28a6b7bacfd1">Crypto_Config</a> *&#160;</td>
          <td class="paramname"><em>ptrCryptoConfig</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group___c_r_y_p_t_o___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga666a80fde1895d919c31bbd4923c6177">Crypto_AESMode</a>&#160;</td>
          <td class="paramname"><em>mode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>cryptoDirection</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>ptrInput</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>dataLength</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>ptrOutput</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group___c_r_y_p_t_o___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga72562d733e0bb69b07ac3f5f42afb10b">Crypto_EncryptParams</a> *&#160;</td>
          <td class="paramname"><em>ptrParams</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 The function is called to encrypt, decrypt or authenticate data based on a specified AES mode. The additional result is stored in the encrypt output parameters.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">ptrCryptoConfig</td><td>Pointer to the Crypto Driver configuration </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">mode</td><td>AES encrypt mode. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">cryptoDirection</td><td>Direction of crypto - Encrypt or Decrypt. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ptrInput</td><td>Pointer to the input data buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dataLength</td><td>Data length in bytes. Valid values are 1 to less than 2^32. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">ptrOutput</td><td>Pointer to the output data buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ptrParams</td><td>Pointer AES parameters. This structure contains both input and output parameters based on the mode.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Success</td><td>- 0 </td></tr>
    <tr><td class="paramname">Error</td><td>- Crypto Error code </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="gae624ba361bba79c602be5a004428ab9d"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static uint32_t Crypto_getAesConfig </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group___c_r_y_p_t_o___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga666a80fde1895d919c31bbd4923c6177">Crypto_AESMode</a>&#160;</td>
          <td class="paramname"><em>mode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group___c_r_y_p_t_o___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga72562d733e0bb69b07ac3f5f42afb10b">Crypto_EncryptParams</a> *&#160;</td>
          <td class="paramname"><em>ptrParams</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 The function figures out the AES module configuration based on the crypto mode.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">mode</td><td>AES crypto mode. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ptrParams</td><td>Pointer AES encrypt parameters.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Success</td><td>- AES module configuration values </td></tr>
    <tr><td class="paramname">Error</td><td>- AES_CFG_MODE_INVALID </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga414429138668a818f1236737c5d8a945"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int32_t Crypto_hmacProcess </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group___c_r_y_p_t_o___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gacd1d473b2a25119de6fa28a6b7bacfd1">Crypto_Config</a> *&#160;</td>
          <td class="paramname"><em>ptrCryptoConfig</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>cryptoConfig</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>ptrInput</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>dataLength</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>ptrSignature</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group___c_r_y_p_t_o___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga8df97ec732f045d62928e614531366b7">Crypto_HmacParams</a> *&#160;</td>
          <td class="paramname"><em>ptrParams</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 The function is used to process the HMAC params and configure the HMAC engine. It sets the HMAC key, processes the input data and produces the hash.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">handle</td><td>Handle to the Crypto Driver </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">cryptoConfig</td><td>HMAC hash algorithm. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ptrInput</td><td>Pointer to the input data buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dataLength</td><td>Data length in bytes. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ptrSignature</td><td>Pointer to the HMAC Hash. input pointer - If HMAC flag was set, the ptrSignature pointer is used as the input HMAC Hash value. output pointer - For the generated Hash value. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ptrParams</td><td>Pointer HMAC parameters.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Success</td><td>- 0 </td></tr>
    <tr><td class="paramname">Error</td><td>- Crypto Error code </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga2bb6398a1750093efe34b44b884a36d8"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HMAC_computeHash </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *&#160;</td>
          <td class="paramname"><em>hmacBaseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>ptrData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>dataLength</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>ptrHashResult</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 This function computes the hash using the algorithm and modes that are configured in the Mode register.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">hmacBaseAddress</td><td>Base address of HMAC module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ptrData</td><td>Pointer to the data buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dataLen</td><td>Data length in bytes. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">ptrHashResult</td><td>Pointer to buffer where hash result is stored.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Not</td><td>applicable </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="gac9a79b134c8df9a39906ec7efc0a2f4f"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HMAC_generateHMACPPKey </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *&#160;</td>
          <td class="paramname"><em>hmacBaseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>ptrKey</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>keySize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>ptrPPKey</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 This function is used to pre process a HMAC key. The pre-processed key can then be used with further HMAC operations to speed up processing time.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">hmacBaseAddress</td><td>Base address of HMAC module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ptrKey</td><td>Pointer to the key. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">keySize</td><td>Key Size in bytes. If the key size is less than 512 bits(64 bytes), the function will be padded with zeros. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">ptrPPKey</td><td>Pointer to the pre-processed key. Must be 64 bytes longs.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Not</td><td>applicable </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga2dd3afef125ee439e8009fc4c486bcc0"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HMAC_writeDataMultiple </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *&#160;</td>
          <td class="paramname"><em>hmacBaseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>ptrData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>dataLength</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 This function writes multiple words of data into the data register. The function waits for each block of data to be processed before another block is written.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">hmacBaseAddress</td><td>Base address of HMAC module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ptrData</td><td>Pointer to the data buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dataLength</td><td>Length of the data in bytes.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Not</td><td>applicable </td></tr>
  </table>
  </dd>
</dl>
<p>Loop through all the blocks and write them into the data registers.</p>
<p>If there are bytes that do not make up a whole block, then write them separately.</p>

</div>
</div>
</div><!-- contents -->
<hr size="1"><small>
Copyright  2018, Texas Instruments Incorporated</small>
</body>
</html>
